package oracle.i18n.demo.obe.gdkshop;

import oracle.i18n.demo.obe.gdkshop.bean.Customer;
import oracle.i18n.demo.obe.gdkshop.bean.Order;

import java.util.Comparator;
import java.util.List;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import oracle.i18n.servlet.ServletHelper;
import oracle.i18n.servlet.Localizer;

public class OrderInformationAction extends HttpServlet
{
  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
    String userid = (String) request.getSession().getAttribute("userid");
    try
    {
      if (userid != null)
      {
        Localizer localizer = ServletHelper.getLocalizerInstance(request);
        request.setAttribute("localizer", localizer);
        long orderId = ShopAction.getOrderId(request);
        Comparator sortDir = ShopAction.getSortDir(request);
        String sortName = ShopAction.getSortingName(request);
        request.setAttribute("sortname", sortName);
        List orderItemList = ShopAction.getOrderItems(orderId, sortName, sortDir, localizer);
        request.setAttribute("orderitems", orderItemList);
        request.setAttribute("comparator", sortDir);
        Customer customer = ShopAction.getCustomer(userid);
        request.setAttribute("customer", customer);
        Order od = ShopAction.getOrder(orderId, localizer);
        request.setAttribute("order", od);
        request.getRequestDispatcher("orderinformation.jsp").forward(request,
          response
        );
      }
      else
        request.getRequestDispatcher("index.jsp").forward(request, response);
    }
    catch (Exception e)
    {
      throw new IllegalStateException(e.getMessage());
    }
  }
}
